Index: trunk/styles/standard/overview.xsl
===================================================================
--- trunk/styles/standard/overview.xsl	(revision 706)
+++ trunk/styles/standard/overview.xsl	(revision 711)
@@ -209,5 +209,5 @@
 
 		<xsl:choose>
-			<xsl:when test="$ypos &lt; 44">
+			<xsl:when test="$ypos &lt; 43">
 				<!-- recursive call - increasing index and output counters -->
 			    <xsl:call-template name="posed_rules">
@@ -305,5 +305,5 @@
 		<xsl:with-param name="key" select="'tracktype'"/>
 		<xsl:with-param name="column" select="2"/>
-		<xsl:with-param name="row" select="10"/>
+		<xsl:with-param name="row" select="8"/>
     </xsl:call-template>
     <xsl:call-template name="topic">
@@ -337,4 +337,9 @@
 		<xsl:with-param name="row" select="28"/>
     </xsl:call-template>
+	<xsl:call-template name="topic">
+		<xsl:with-param name="key" select="'barrier'"/>
+		<xsl:with-param name="column" select="2"/>
+		<xsl:with-param name="row" select="30"/>
+    </xsl:call-template>
     <xsl:call-template name="topic">
 		<xsl:with-param name="key" select="'route'"/>
@@ -399,57 +404,47 @@
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'oneway'"/>
+		<xsl:with-param name="key" select="'noexit'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="23"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'noexit'"/>
-		<xsl:with-param name="column" select="3"/>
-		<xsl:with-param name="row" select="25"/>
-    </xsl:call-template>
-	<xsl:call-template name="topic">
 		<xsl:with-param name="key" select="'maxweight'"/>
 		<xsl:with-param name="column" select="3"/>
+		<xsl:with-param name="row" select="25"/>
+    </xsl:call-template>
+	<xsl:call-template name="topic">
+		<xsl:with-param name="key" select="'maxheight'"/>
+		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="27"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'maxheight'"/>
+		<xsl:with-param name="key" select="'maxwidth'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="29"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'maxwidth'"/>
+		<xsl:with-param name="key" select="'maxlength'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="31"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'maxlength'"/>
+		<xsl:with-param name="key" select="'maxspeed'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="33"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'maxspeed'"/>
+		<xsl:with-param name="key" select="'minspeed'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="35"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'minspeed'"/>
+		<xsl:with-param name="key" select="'maxstay'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="37"/>
     </xsl:call-template>
 	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'maxstay'"/>
+		<xsl:with-param name="key" select="'toll'"/>
 		<xsl:with-param name="column" select="3"/>
 		<xsl:with-param name="row" select="39"/>
-    </xsl:call-template>
-	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'toll'"/>
-		<xsl:with-param name="column" select="3"/>
-		<xsl:with-param name="row" select="41"/>
-    </xsl:call-template>
-	<xsl:call-template name="topic">
-		<xsl:with-param name="key" select="'barrier'"/>
-		<xsl:with-param name="column" select="3"/>
-		<xsl:with-param name="row" select="43"/>
     </xsl:call-template>
 		
@@ -462,10 +457,10 @@
 		<xsl:with-param name="key" select="'service'"/>
 		<xsl:with-param name="column" select="4"/>
-		<xsl:with-param name="row" select="20"/>
+		<xsl:with-param name="row" select="21"/>
     </xsl:call-template>
     <xsl:call-template name="topic">
 		<xsl:with-param name="key" select="'waterway'"/>
 		<xsl:with-param name="column" select="4"/>
-		<xsl:with-param name="row" select="25"/>
+		<xsl:with-param name="row" select="26"/>
     </xsl:call-template>
 	