Index: trunk/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java	(revision 1216)
+++ trunk/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java	(revision 1221)
@@ -752,14 +752,21 @@
                 g.drawRect(p.x - radius, p.y - radius, size, size);
 
-			String name = getNodeName(n);
-			if (name!=null /* && annotate */)
-			{
-				g.setColor(textColor);
-				Font defaultFont = g.getFont();
-				g.setFont (orderFont);
-				g.drawString (name, p.x+radius+2, p.y+radius+2);
-				g.setFont(defaultFont);
-			}
-        }
+            String name = getNodeName(n);
+            if (name!=null /* && annotate */)
+            {
+                g.setColor(textColor);
+                Font defaultFont = g.getFont();
+                g.setFont (orderFont);
+                g.drawString (name, p.x+radius+2, p.y+radius+2);
+                g.setFont(defaultFont);
+            }
+        }
+    }
+
+    public void getColors()
+    {
+        super.getColors();
+        untaggedColor = Main.pref.getColor(marktr("untagged"),Color.GRAY);
+        textColor = Main.pref.getColor (marktr("text"), Color.WHITE);
     }
 
@@ -767,17 +774,15 @@
     // Shows areas before non-areas
     public void visitAll(DataSet data, Boolean virtual) {
-	
-		boolean profiler = Main.pref.getBoolean("mappaint.profiler",false);
-		long profilerStart = java.lang.System.currentTimeMillis();
-		long profilerLast = profilerStart;
-		int profilerN;
-		if(profiler)
-		{
-			System.out.println("Mappaint Profiler");
-		}
-		
+
+        boolean profiler = Main.pref.getBoolean("mappaint.profiler",false);
+        long profilerStart = java.lang.System.currentTimeMillis();
+        long profilerLast = profilerStart;
+        int profilerN;
+        if(profiler)
+        {
+            System.out.println("Mappaint Profiler");
+        }
+
         getSettings(virtual);
-        untaggedColor = Main.pref.getColor(marktr("untagged"),Color.GRAY);
-        textColor = Main.pref.getColor (marktr("text"), Color.WHITE);
         useRealWidth = Main.pref.getBoolean("mappaint.useRealWidth",false);
         zoomLevelDisplay = Main.pref.getBoolean("mappaint.zoomLevelDisplay",false);
@@ -795,32 +800,32 @@
         selectedCall = false;
 
-		if(profiler) 
-		{
-			System.out.format("Prepare  : %4dms\n", (java.lang.System.currentTimeMillis()-profilerLast));
-			profilerLast = java.lang.System.currentTimeMillis();
-		}
-		
+        if(profiler) 
+        {
+            System.out.format("Prepare  : %4dms\n", (java.lang.System.currentTimeMillis()-profilerLast));
+            profilerLast = java.lang.System.currentTimeMillis();
+        }
+
         if (fillAreas && styles.hasAreas()) {
             Collection<Way> noAreaWays = new LinkedList<Way>();
 
-			/*** RELATIONS ***/
-			profilerN = 0;
+            /*** RELATIONS ***/
+            profilerN = 0;
             for (final Relation osm : data.relations)
             {
                 if(!osm.deleted && !osm.incomplete)
-				{
+                {
                     osm.visit(this);
-					profilerN++;
-				}
-            }
-
-			if(profiler) 
-			{
-				System.out.format("Relations: %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-				profilerLast = java.lang.System.currentTimeMillis();
-			}
-			
-			/*** AREAS ***/
-			profilerN = 0;
+                    profilerN++;
+                }
+            }
+
+            if(profiler) 
+            {
+                System.out.format("Relations: %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+                profilerLast = java.lang.System.currentTimeMillis();
+            }
+
+            /*** AREAS ***/
+            profilerN = 0;
             for (final Way osm : data.ways)
             {
@@ -836,13 +841,13 @@
             }
             alreadyDrawnAreas = null;
-			
-			if(profiler) 
-			{
-				System.out.format("Areas    : %4dms, n=%d\n",  (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-				profilerLast = java.lang.System.currentTimeMillis();
-			}
-
-			/*** WAYS ***/
-			profilerN = 0;
+
+            if(profiler)
+            {
+                System.out.format("Areas    : %4dms, n=%d\n",  (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+                profilerLast = java.lang.System.currentTimeMillis();
+            }
+
+            /*** WAYS ***/
+            profilerN = 0;
             fillAreas = false;
             for (final OsmPrimitive osm : noAreaWays)
@@ -851,96 +856,96 @@
                 profilerN++;
             }
-			
-			if(profiler) 
-			{
-				System.out.format("Ways     : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-				profilerLast = java.lang.System.currentTimeMillis();
-			}
+
+            if(profiler)
+            {
+                System.out.format("Ways     : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+                profilerLast = java.lang.System.currentTimeMillis();
+            }
         }
         else
         {
-			/*** WAYS (filling disabled)  ***/			
-			profilerN = 0;
+            /*** WAYS (filling disabled)  ***/
+            profilerN = 0;
             for (final OsmPrimitive osm : data.ways)
                 if (!osm.incomplete && !osm.deleted && !osm.selected)
-				{
+                {
                     osm.visit(this);
                     profilerN++;
-				}
-					
-			if(profiler) 
-			{
-				System.out.format("Ways     : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-				profilerLast = java.lang.System.currentTimeMillis();
-			}
-        }
-
-		/*** SELECTED  ***/
+                }
+
+            if(profiler)
+            {
+                System.out.format("Ways     : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+                profilerLast = java.lang.System.currentTimeMillis();
+            }
+        }
+
+        /*** SELECTED  ***/
         selectedCall = true;
-		profilerN = 0;
+        profilerN = 0;
         for (final OsmPrimitive osm : data.getSelected()) {
             if (!osm.incomplete && !osm.deleted
             && !(osm instanceof Node) && !alreadyDrawn.contains(osm))
-			{
+            {
                 osm.visit(this);
-				profilerN++;
-			}
-        }
-		
-		if(profiler) 
-		{
-			System.out.format("Selected : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-			profilerLast = java.lang.System.currentTimeMillis();
-		}
-
-		/*** DISPLAY CACHED SEGMENTS (WAYS) NOW ***/
+                profilerN++;
+            }
+        }
+
+        if(profiler)
+        {
+            System.out.format("Selected : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+            profilerLast = java.lang.System.currentTimeMillis();
+        }
+
+        /*** DISPLAY CACHED SEGMENTS (WAYS) NOW ***/
         displaySegments();
-		/*System.out.println("display segments " + (java.lang.System.currentTimeMillis()-profilerLast) + "ms");
-		profilerLast = java.lang.System.currentTimeMillis();*/
-
-		/*** NODES ***/
-		profilerN = 0;
+        /*System.out.println("display segments " + (java.lang.System.currentTimeMillis()-profilerLast) + "ms");
+        profilerLast = java.lang.System.currentTimeMillis();*/
+
+        /*** NODES ***/
+        profilerN = 0;
         for (final OsmPrimitive osm : data.nodes)
             if (!osm.incomplete && !osm.deleted && !alreadyDrawn.contains(osm))
             {
                 osm.visit(this);
-				profilerN++;
-			}
-				
-		if(profiler) 
-		{
-			System.out.format("Nodes    : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-			profilerLast = java.lang.System.currentTimeMillis();
-		}
+                profilerN++;
+            }
+
+        if(profiler)
+        {
+            System.out.format("Nodes    : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+            profilerLast = java.lang.System.currentTimeMillis();
+        }
 
         alreadyDrawn = null;
 
-		/*** VIRTUAL  ***/
+        /*** VIRTUAL  ***/
         if (virtualNodeSize != 0)
         {
-			profilerN = 0;
+            profilerN = 0;
             currentColor = nodeColor;
             for (final OsmPrimitive osm : data.ways)
                 if (!osm.incomplete && !osm.deleted)
-				{
+                {
                     visitVirtual((Way)osm);
-					profilerN++;
-				}
-					
-			if(profiler) 
-			{
-				System.out.format("Virtual  : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
-				profilerLast = java.lang.System.currentTimeMillis();
-			}
-            
-			displaySegments(null);
-			/*System.out.println("display segments virtual " + (java.lang.System.currentTimeMillis()-profilerLast) + "ms");
-			profilerLast = java.lang.System.currentTimeMillis();*/
-        }
-		
-		if(profiler) 
-		{
-			System.out.format("All      : %4dms\n", (profilerLast-profilerStart));
-		}
+                    profilerN++;
+                }
+
+            if(profiler)
+            {
+                System.out.format("Virtual  : %4dms, n=%d\n", (java.lang.System.currentTimeMillis()-profilerLast), profilerN);
+                profilerLast = java.lang.System.currentTimeMillis();
+            }
+
+            displaySegments(null);
+            /*System.out.println("display segments virtual " + (java.lang.System.currentTimeMillis()-profilerLast) + "ms");
+            profilerLast = java.lang.System.currentTimeMillis();*/
+        }
+
+        if(profiler)
+        {
+            System.out.format("All      : %4dms\n", (profilerLast-profilerStart));
+        }
     }
 
Index: trunk/src/org/openstreetmap/josm/data/osm/visitor/SimplePaintVisitor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/visitor/SimplePaintVisitor.java	(revision 1216)
+++ trunk/src/org/openstreetmap/josm/data/osm/visitor/SimplePaintVisitor.java	(revision 1221)
@@ -85,8 +85,9 @@
     Rectangle bbox = new Rectangle();
 
-    protected void getSettings(Boolean virtual) {
-        inactiveColor = Main.pref.getColor(marktr("inactive"), Color.DARK_GRAY);
-        selectedColor = Main.pref.getColor(marktr("selected"), Color.WHITE);
-        nodeColor = Main.pref.getColor(marktr("node"), Color.RED);
+    public void getColors()
+    {
+        inactiveColor = Main.pref.getColor(marktr("inactive"), Color.darkGray);
+        selectedColor = Main.pref.getColor(marktr("selected"), Color.red);
+        nodeColor = Main.pref.getColor(marktr("node"), Color.yellow);
         dfltWayColor = Main.pref.getColor(marktr("way"), darkblue);
         relationColor = Main.pref.getColor(marktr("relation"), teal);
@@ -94,4 +95,7 @@
         incompleteColor = Main.pref.getColor(marktr("incomplete way"), darkerblue);
         backgroundColor = Main.pref.getColor(marktr("background"), Color.BLACK);
+    }
+
+    protected void getSettings(Boolean virtual) {
         showDirectionArrow = Main.pref.getBoolean("draw.segment.direction");
         showRelevantDirectionsOnly = Main.pref.getBoolean("draw.segment.relevant_directions_only", true);